package compilateur;


import compilateur.cspLangage.Type;

import util.Var;
import util.VarAlreadyExistsException;
import util.VarManager;
import util.VarProvider;

public class CspVarManager extends VarManager<CspVar, JavaVar> {

	protected CspVar provideVar(String name, Type type, VarManager<CspVar, JavaVar> parent) {
		return new CspVar (name, type, parent);
	}

	
	/**
	 * Ici, on override 'addVariable' afin d'ajouter la possiblit de redclarer
	 * une variable, qu'elle soit dclare dans la liste de commandes concerne ou
	 * dans une liste de commandes parente.
	 */
	public CspVar addVariable (String name, Type type) throws VarAlreadyExistsException {
		CspVar var = searchVarInThis(name);		
		if (var!=null)
			getVarList().remove(var);
		CspVar v = provideVar(name, type, this);
		getVarList().add(v);
		return v;
	}
	
}
