
package compilateur;

import java.io.File;
import java.io.IOException;

import util.UTF_FileOutputStream;


public class Tool {

	public static String createNewName (String base) {
		
		if (base.lastIndexOf('$')!=-1) {
			String indice = base.substring(base.lastIndexOf('$') + 1);
			if (indice.matches("^[0-9]$")) {
				indice = String.valueOf(Integer.valueOf(indice) + 1);
				
				return base.substring(0, base.lastIndexOf('$')) + "$" + indice;
			}
		}
		
		return base + "$0";
	}
	
	public static void newJavaFile (String packageName, String filename, String content) throws IOException, CompilationException {
		
		String name = packageName.replaceAll("\\.", "/");
		File dir = new File (name);
	
		if (!dir.exists() || (dir.exists() && !dir.isDirectory()))
			if (!dir.mkdirs())
				throw new CompilationException ("Impossible de crer le repertoire " + packageName);
					
		UTF_FileOutputStream out;
		out = new UTF_FileOutputStream(dir.getAbsolutePath() + File.separatorChar + filename);
		
		out.print(formatJavaCode (content)); 
		
		out.close ();
	}

	public static String formatJavaCode(String content) {
		String finalContent = "";
		String lignes [] = content.split("\\n");
		
		int indent = 0;
		for (String ligne : lignes) {
			finalContent += makeIndent (indent) + ligne + "\n";
			for (char c : ligne.toCharArray()) {
				if (c=='{') indent++;
				else if (c=='}') indent --;
			}	
		}
		return finalContent;
	}

	private static String makeIndent(int indent) {
		String txt = "";
		for (int i=0;i<indent;i++) txt += "\t";
		return txt;
	}
	
	
	public static String compile (String format, String ... params) {
		String content = format;
		
		for (int i=0;i<params.length;i++) {
			String rempl = params[i].replaceAll("\\\\", "\\\\\\\\");
			rempl = rempl.replaceAll("\\$", "\\\\\\$");
			content = content.replaceAll("(\\<%" + i + "\\>)", rempl);
		}
		
		return content;
	}
	
	
	public static void main (String args[]) {
		
		System.out.println (compile ("for (<%0>=0;<%0><5;<%0>++)", "i"));
		
	}
	
}
