package compilateur.cspLangage;

import java.util.Vector;

import compilateur.CompilationException;


public class ArrayType extends Type {

	public Vector<Range> ranges = new Vector<Range>();
	public SimpleType type;
	public Commande parent; 
	
	public ArrayType(Commande parent2) {
		this.parent = parent2;
	}

	@Override
	public String compileDeclaration(String var) {
		String content = "";
		
		content += "final CspArray<" + type.compile() +">" + var;
		
		return content;
	}

	@Override
	public String compileDefaultValueConstructeur() throws CompilationException {
		String content = "";
		
		content += "new CspArray<"+ type.compile () + ">";
		content += "(" + type.getDefaultValue();
		
		for (Range r : ranges) {
			r.parentCmd = parent;
			content += ", new Borne(" + r.borneInf.compile() + ", " + r.borneSup.compile() + ")";
		}
		
		content +=")";
		
		return content;		
	}

	@Override
	public String compileAffect(String var, String contentSource) {
		return var + ".copyFrom(" + contentSource + ")";
	}

	@Override
	public String buildCsp() throws CompilationException {
		String content = "";
		
		content += "[";
		
		for (int i=0;i<ranges.size();i++) {
			content += ranges.get(i).buildCsp ();
			if (i!=ranges.size()-1) content += ", ";
		}
		
		content += "] " + type.buildCsp() ;
		
		return content;
	}

	@Override
	public String compileGet(String var) {
		return var;
	}

	@Override
	public boolean equals(Type t) {
		if (t instanceof ArrayType)
			if (((ArrayType)t).type.equals(type))
				return true;
		return false;
	}

}
