package compilateur.cspLangage;
import java.util.Vector;

import util.Var;

import compilateur.CompilationException;
import compilateur.CspVar;
import compilateur.JavaVar;
import compilateur.Tool;

import compilateur.cspLangage.ListeCommande.*;
import antlr.Token;

/*
 * Created on 18 mai 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

/**
 * @author Administrateur
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class CommandeAlternative extends Commande {

	public Vector<CommandeGardee> liste;
	
	public static final int REPETITIVE = 0;
	public static final int ALTERNATIVE = 1;
	
	public int type = ALTERNATIVE;

	public CommandeAlternative(ListeCommande parent) {
		this.parent = parent;
	}


	public void preCompile () {
		
		for (CommandeGardee cmd : liste) {
			cmd.preCompile();					
		}
		
	}
	
	
	public String compile () throws CompilationException {
		String content = "";

		content += "/* " + ((type==REPETITIVE)?"*":"") + "[ ... [] ... ]" + " */\n";
		
		if (liste.size()==1 && liste.get(0).listeRange.size()==0) {
			CommandeGardee cmd = liste.get(0);
			String condition = "";
			Token first, last;
			if (cmd.garde.exprBool!=null) condition += cmd.garde.exprBool.compile();
			if (cmd.garde.commandeES!=null) {
				condition += (condition.equals(""))?"":" && ";
				condition += cmd.garde.commandeES.compileSimple();
			}
			
			if (cmd.garde.exprBool==null)
				first = cmd.garde.commandeES.firstToken;
			else
				first = cmd.garde.exprBool.first;
			if (cmd.garde.commandeES==null)
				last = cmd.garde.exprBool.last;
			else
				last = cmd.garde.commandeES.lastToken;
			
			content += "/* " + buildCspSelective (0) + " */\n";
			
			String contentListe = "";
			contentListe += "debug (new DebugObj(" + first.getLine () + ", ";
			contentListe += first.getColumn() + ", ";
			contentListe += last.getLine() + ", ";
			contentListe += last.getColumn() + "));\n";
			
			contentListe += "if (!" + condition + ") break;\n";
			
			contentListe += cmd.compileListeCommande();
			content += Tool.compile ("while (true) {\n<%0>\n<%1>\n}\n",
						contentListe, 
						(type==ALTERNATIVE)?"break;":"");
		} else {
			// dclaration de la variable "select" puis compilation de son initialisation
			Var variableSelect = parent.getCspVarList().getLinkedManager().obtainVar("select", new TypeSimple("Select", "null"));			
			content += compileSelect (variableSelect.getName()) + "\n";
			
			JavaVar variableCh = parent.getCspVarList().getLinkedManager().obtainVar("ch", new TypeSimple("int", "0"));
			
			JavaVar variableRange = parent.getCspVarList().getLinkedManager().obtainVar("range", new TypeSimple("int []", "null"));
			
			
			/* declaration des gardes et recup des liste de commande */
			String listeExprBool = "";
			String refInputOuput = "";
			String contentExec = "";
			
			contentExec += Tool.compile ("int <%0> = <%1>.getChoice();\n",
					variableCh.getName(), variableSelect.getName());
			contentExec += Tool.compile ("int [] <%0> = <%1>.getRange ();\n",
					variableRange.getName(), variableSelect.getName());
			
			String condition = variableSelect + ".select()";
			for (int i=0;i<liste.size();i++) {
				CommandeGardee cmd = liste.get(i);
				
				if (cmd.garde.exprBool!=null) listeExprBool += cmd.compileExprBool () + "\n";
				refInputOuput += cmd.compileRefInputOutput (variableSelect.getName(), i) + "\n";
				
				contentExec += "/* " + buildCspSelective(i) + " */\n";
				contentExec += Tool.compile ("if (<%0>==<%1>) {\n", variableCh.getName(), i+"");
				contentExec += cmd.compileDeclarationIndices (variableRange.getName()) + "\n";
				contentExec += cmd.compileListeCommande ();
				contentExec += "}\n";
			}
			
			content += listeExprBool;
			content += refInputOuput;

			
			content += "if (!" + condition + ") break;\n";
			content += contentExec;
			
			if (type==REPETITIVE) {
				content = "while (true) {\n" + content + "}\n";
			}
		}
		return content;
	}


	private String compileSelect(String variableSelect) {
		return Tool.compile ("Select <%0> = getNewSelect();", variableSelect);
	}


	@Override
	public void changeVariable(String oldVar, String newVar) {
		if (liste!=null) 
			for (CommandeGardee cmd : liste)
				cmd.changeVariable (oldVar, newVar);
	}
	
	public String buildCspSelective (int num) throws CompilationException {
		return liste.get(num).buildCsp () + " ->";
	}
		
}
