package compilateur.cspLangage;
import java.lang.reflect.Constructor;
import java.util.Vector;

import util.Var;

import compilateur.CompilationException;
import compilateur.JavaVar;
import compilateur.PTokenTypes;
import compilateur.cspLangage.ListeCommande.VariableItem;

import antlr.Token;

/*
 * Created on 18 mai 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

/**
 * @author Administrateur
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class CommandeParallele extends Commande {

	public Vector<Processus> listeProcessus;
	public static Programme currentProg;

	public CommandeParallele(ListeCommande parent) {
		this.parent = parent;
	}

	public void preCompile () {
		
		// macrotisation
		for (Processus p : listeProcessus) {
			if (p.idListeCommande==null) {
				String nom = currentProg.addAnonymousMacro(p.listeCommande);
				p.idListeCommande = new Identifier (nom);
				p.listeCommande.listeParent = parent;
				p.listeCommande.preCompile();
				p.listeCommande = null;
			}
		}
		
	}
	
	public String compile () throws CompilationException {
		String content = "";
		
		/*
		 * Il y a 3 parties dans le rsultat de la compilation d'une cmd parallele :
		 * 1) dclaration des processus (appel constructeur)
		 * 2) paramtrage des variables  (appel mthode 'setVariables') et lancement
		 * des processus
		 * 3) attente de la terminaison des processus
		 */
		
		String declaration = "";
		String lancement = "";
		String terminaison = "";
		
		// Avant de commencer la compilation, on rfrence les processus
		// comme tant des variables dans la liste de commande parente
		for (Processus p : listeProcessus) {
			TypeProcessus type =new TypeProcessus (p);
			parent.getCspVarList().addLinkedVariable(p.label.nomProcessus.toString(), type, new TypeProcessus(p));
			//parent.putVariable(p.label.nomProcessus.toString(), type, ListeCommande.VariableItem.USER, parent.getMacroParent());
		}

		JavaVar varTerm = parent.getCspVarList().getLinkedManager().obtainVar("procSuccess", new TypeSimple("boolean", "false"));
		//parent.putVariable(varTerm, new TypeSimple("Boolean", "true"), VariableItem.COMPILATEUR, parent.getMacroParent());

		terminaison += "boolean " + varTerm + " = true;\n";
		
		// compilation
		for (Processus p : listeProcessus) {
			Macro m = currentProg.getMacro(p.idListeCommande.toString());
			if (m.compiled) checkMacro (m, p);
			else {
				m.getJavaVarList().setParentManager(parent.getCspVarList().getLinkedManager());
				m.getListe().getCspVarList().setParentManagerOnly(parent.getCspVarList());
				m.parentMacro = parent.getMacroParent();
				//m.getListe().parentMacro = parent
				
				m.indices = p.label.listeIndice;
				
				m.compile ();
			}

			declaration += p.compileDeclaration (m.variablesExternes) + "\n";
			lancement += p.compileLancement (m.variablesExternes) + "\n";
			terminaison += p.compileTerminaison (varTerm) + "\n";

		}
		terminaison += "if (!" + varTerm + ") break;";
		
		content += "/* " + buildCsp () + " */\n";
		content += declaration +"\n";
		content += lancement + "\n";
		content += terminaison + "\n";
		
		return content;
	}

	private void checkMacro(Macro m, Processus p) throws CompilationException {
		
		// on vrifie que les variables externes sont bien prsentes
		Var v;
		for (Var var : m.variablesExternes) {
			if ((v=parent.getVar(var.getName()))==null) 
				throw new CompilationException (p.label.nomProcessus.token,
						"La variable " + var.getName() + " n'existe pas dans cette liste de commandes");
			else
				if (!v.getType().equals (var.getType()))
						throw new CompilationException (p.label.nomProcessus.token,
								"Il n'existe pas de variable <" + var.getName() + "> de type <" + var.getType().buildCsp() + "> dans le processus parent");
		}
		
		// et on vrifie que l'indicage correspond bien
		if ((m.indices != null) && (p.label.listeIndice != null) && (m.indices.size() != p.label.listeIndice.size())
				||
				((m.indices == null || p.label.listeIndice == null) && (m.indices != p.label.listeIndice)))
			throw new CompilationException (p.label.nomProcessus.token,
				"les indices dja dfinis ne correspondent pas avec la commande actuelle");
			
	}

	private String buildCsp() throws CompilationException {
		String content = "";
		
		content += "[";
		
		for (int i=0;i<listeProcessus.size();i++) {
			if (i!=0) content += " || ";
			content += listeProcessus.get(i).buildCsp();			
		}
		
		content += "]";
		
		return content;
	}

	@Override
	public void changeVariable(String oldVar, String newVar) {
		for (Processus p : listeProcessus)
			p.changeVariable (oldVar, newVar);
	}
	
}
