package compilateur.cspLangage;
import java.util.Vector;

import compilateur.CompilationException;
import compilateur.CspVar;
import compilateur.cspLangage.ListeCommande.VariableItem;


/*
 * Created on 18 mai 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

/**
 * @author Administrateur
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ExpressionStructuree extends Expression {

	public Identifier constructeur;
	public Vector<Expression> expressions;
	
	public ExpressionStructuree(Commande parent) {
		this.parent = parent;
	}

	@Override
	public String compileConstructeur() throws CompilationException {
		return compile ();
	}
	
	@Override
	public String compile() throws CompilationException {
		String content = "";
		
		content += "new Expression (\"" + constructeur.toString() + "\"";
		
		if (expressions!=null) {
			for (Expression e : expressions) {
				e.parent = parent;
				if (e instanceof Variable) {
					CspVar item = parent.parent.getVar(((Variable)e).toString());
					if (item==null)
						throw new CompilationException(((Variable)e).getToken(), "Variable non dclare");
					if (item.getType() instanceof TypeSimple)
						content += ", " + e.compileConstructeur();
					else
						content += ", " + item.getLinkedVar().getName();
				} else {
					content += ", " + e.compileConstructeur();
				}
			}
		}
		content += ")";
		
		return content;
	}

	@Override
	public String buildCsp() throws CompilationException {
		String content = "";
		
		content += constructeur.toString() + "(";
		
		if (expressions != null) {
			for (int i=0;i<expressions.size();i++) {
				content += expressions.get(i).buildCsp();
				if (i!=expressions.size()-1) content += ", ";
			}
		}
		
		content += ")";
		
		return content;
	}

	public static ExpressionStructuree constructNewExpr (Expression expression) {
		ExpressionStructuree expr = new ExpressionStructuree(expression.parent);
		expr.constructeur = new Identifier("none");
		expr.expressions = new Vector<Expression>();
		expr.expressions.add (expression);
		return expr;
	}

	@Override
	public void changeVariable(String oldVar, String newVar) {
		for (Expression e : expressions)
			e.changeVariable(oldVar,newVar);
	}
	
}
