package compilateur.cspLangage;

import java.util.Vector;

import compilateur.CompilationException;


public class ExpressionTab extends Expression {

	public ExpressionSimple expression;
	public Vector<Range> ranges = new Vector<Range>(); 

	public ExpressionTab(Commande parent) {
		this.parent = parent;
	}

	@Override
	public String compileConstructeur() throws CompilationException {
		String content = "";

		content += "CspArray.newCspArray";
		content += "(" + expression.compile();
		
		for (Range r : ranges) {
			r.parentCmd = parent;
			content += ", new Borne(" + r.borneInf.compile() + ", " + r.borneSup.compile() + ")";
		}
		
		content +=")";
		
		
		return content;
	}

	@Override
	public String compile() throws CompilationException {
		return compileConstructeur ();
	}

	@Override
	public String buildCsp() throws CompilationException {
		String content = "";
		
		content += "[";
		
		for (int i=0;i<ranges.size();i++) {
			content += ranges.get(i).buildCsp();
			if (i != ranges.size()-1) content += ", ";
		}
		
		content += "] " + expression.buildCsp();
		
		return content;
	}

	@Override
	public void changeVariable(String oldVar, String newVar) {
		expression.changeVariable(oldVar,newVar);
		for (Range r : ranges) {
			r.parentCmd = parent;
			r.changeVariable(oldVar, newVar);
		}
	}

}
