package compilateur.cspLangage;
import java.util.Vector;

import util.Var;

import compilateur.CompilationException;
import compilateur.CspVar;
import compilateur.JavaVar;
import compilateur.Tool;

import compilateur.cspLangage.ListeCommande.*;


/*
 * Created on 18 mai 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

/**
 * @author Administrateur
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Processus  extends LangageToken {

	public LabelProcessus label;
	public ListeCommande listeCommande;
	public Identifier idListeCommande;
	
	public Commande parent;
	
	public Processus(Commande cmd) {
		this.parent = cmd;
	}

	public String compileDeclaration(Vector<CspVar> varExternes) throws CompilationException {
		String content = "";
		
		String type = idListeCommande.toString();
		String nom = label.nomProcessus.toString();
		CspVar procVar = parent.parent.getVar(label.nomProcessus.toString());
		String varExternesStr = compileVariablesNonProcessus(varExternes);
		varExternesStr = (varExternesStr.equals(""))?"":", " + varExternesStr;
		
		if (label.listeIndice==null) {
			content += type + " " + procVar.getLinkedVar().toString() + " = new " + type + "(\"" + nom + "\"" + varExternesStr + ");";
		} else {
			String partieGauche = "";
			String partieDroite = "";
			String forDeclaration = "";
			
			String listeParams = "";
			String forBody = procVar.getLinkedVar().toString();
			
			partieGauche = type;
			partieDroite = "new " + type;
			for (IndiceLabel indice : label.listeIndice) {
				// declaration de la variable d'indicage
				parent.parent.getCspVarList().addLinkedVariable(indice.range.variable.toString(), new TypeSimple ("integer", "0"), new TypeSimple("int", "0"));
				partieGauche += "[]";
				partieDroite += "[";
				partieDroite += indice.range.borneSup.compile() + "-" + 
							indice.range.borneInf.compile () + "+1";
				partieDroite += "]";
				forDeclaration += indice.range.compileFor () + "\n";
				forBody += "[" + indice.range.variable.compile() + "]";
				listeParams += ", " + indice.range.variable.compile() + "+" + indice.range.borneInf.compile ();
			}
			
			listeParams += varExternesStr;
			
			partieGauche += procVar.getLinkedVar().toString();
			content += partieGauche + " = " + partieDroite + ";\n";
			
			forBody += " =  new " + type + "(\"" + nom + "\"" + listeParams +");";
			
			content += forDeclaration + forBody;
			
		}
		
		return content;
	}

	public String compileLancement(Vector<CspVar> varExternes) throws CompilationException {
		String content = "";
		
		content = label.compileForIndices(compileSetAndStart(compileVariablesProcessus(varExternes)));	
		
		return content;
	}
	
	private String compileSetAndStart (String varExternes) throws CompilationException {
		String content = "";
	
		content = Tool.compile ("<%0>.setVariables(<%1>);\n<%0>.start();",
				label.compile (),
				varExternes);
		
		return content;
	}

	private String compileVariablesProcessus (Vector<CspVar> varExternes) {
		String content = null;
		
		for (CspVar var : varExternes) {
			Type type = var.getType();
			if (type instanceof TypeProcessus) {
				if (content==null) content = var.getLinkedVar().getName();
				else 
					content += ", " + var.getLinkedVar().getName();
			}
		}

		return (content==null)?"":content;
	}

	private String compileVariablesNonProcessus (Vector<CspVar> varExternes) {
		String content = null;
		
		for (Var var : varExternes) {
			Type type = var.getType();
			if (!(type instanceof TypeProcessus)) {
				if (content==null) content = var.getLinkedVar().getName();
				else content += ", " + var;
			}
		}

		return (content==null)?"":content;
	}

	
	public String compileTerminaison(JavaVar varTerm) throws CompilationException {
		String content = "";
		return label.compileForIndices(compileJoin(varTerm.getName()));	
	}

	private String compileJoin(String var) throws CompilationException {
		return Tool.compile ("if (!<%0>.join()) " + var + "=false;",
				label.compile ());				
	}

	public String buildCsp() throws CompilationException {
		return label.buildCsp () + "::" + idListeCommande.toString();
	}

	public void changeVariable(String oldVar, String newVar) {
		label.changeVariable(oldVar,newVar);
		listeCommande.changeVariable(oldVar,newVar);
		idListeCommande.changeVariable(oldVar,newVar);		
	}
	
}
