package compilateur.cspLangage;

import java.util.HashMap;

import compilateur.CompilationException;


public abstract class Type extends LangageToken {
	
	private static final Type typeInteger = new SimpleType("integer");
	private static final Type typeBoolean = new SimpleType("boolean");
	private static final Type typeString = new SimpleType("string");
		
	private static HashMap<String, Type[]> operateurMap = new HashMap <String, Type[]> ();
	static {
		operateurMap.put("+", new Type[]{typeInteger, typeString});
		operateurMap.put("-", new Type[]{typeInteger});
		//operateurMap.put("<", new Type[]{type});
	}
	
	public abstract boolean equals (Type t);
	
	public abstract String compileDeclaration(String var) throws CompilationException;

	public abstract String compileDefaultValueConstructeur() throws CompilationException;

	public String compile() {
		// TODO Auto-generated method stub
		return null;
	}

	public abstract String compileAffect(String var, String contentSource) throws CompilationException;

	public abstract String buildCsp() throws CompilationException;

	public abstract String compileGet(String var) throws CompilationException;

	public void changeVariable(String oldVar, String newVar) {
		
	}
		
}
