package compilateur.cspLangage;

import java.util.Vector;

import compilateur.CompilationException;


public class TypeStructuree extends Type {

	public Identifier constructeur = new Identifier("none");
	public Vector<Type> types = new Vector<Type>();
	
	@Override
	public String compileDefaultValueConstructeur() throws CompilationException {
		String content = "";
		
		content += "new Expression(\"" + constructeur + "\"";
		for (Type t : types) {
			content += ", " + t.compileDefaultValueConstructeur();
		}
		content += ")";
				
		return content;
	}
	
	@Override
	public String compileDeclaration(String var) {
		String content = "";
		
		content += "final Expression " + var;
		
		return content;
	}

	@Override
	public String compileAffect(String var, String contentSource) {
		return var + ".copyFrom(" + contentSource + ")";
	}

	@Override
	public String buildCsp() throws CompilationException {
		String content = "";
		
		content += constructeur.toString() + "(";
		
		for (int i=0;i<types.size();i++) {
			content += types.get(i).buildCsp();
			if (i!=types.size()-1) content += ", ";
		}
		
		content += ")";
		return content;
	}

	@Override
	public String compileGet(String var) {
		return var;
	}

	@Override
	public boolean equals(Type t) {
		if (t instanceof TypeStructuree)
			return true;
		return false;
	}
	
	
}
