package util;

import java.awt.GridBagConstraints;
import java.awt.Insets;

/**
 * GBFactory (GridBagFactory) permet de simplifier l'utilisation du layout GridBagLayout.
 * 
 * @author Benjamin LE BOZEC
 *
 */
public class GBFactory {

	private static GridBagConstraints cst = new GridBagConstraints ();
	
	public static GridBagConstraints getCst (
			int gx,
			int gy,
			int gw,
			int gh,
			int wx,
			int wy,
			int fill) {
		return getCst (gx, gy, gw, gh, wx, wy, new Insets(0,0,0,0), GridBagConstraints.CENTER, fill);
	}
	
	public static GridBagConstraints getCst (
			int gx,
			int gy,
			int gw,
			int gh,
			int wx,
			int wy,
			Insets insets,
			int anchor,
			int fill) {
		cst.gridx = gx;
		cst.gridy = gy;
		cst.gridheight = gh;
		cst.gridwidth = gw;
		cst.weightx = wx;
		cst.weighty = wy;
		cst.insets = insets;
		cst.anchor = anchor;
		cst.fill = fill;
		return cst;
	}
	
}
