package util;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FilenameFilter;
import java.io.IOException;

public class MyLoader extends ClassLoader {

	public void load (String packageName) throws IOException {
		
		String dir = packageName.replaceAll("\\.", "/");
		
		File [] files = new File(dir).listFiles(new FilenameFilter() {
		
			public boolean accept(File dir, String name) {
				if (name.endsWith(".class")) return true;
				return false;
			}
		
		});
		
		byte buffer [];
		int lus, total;
		int size;
		FileInputStream input;
		String className;
		for (File f : files) {
			size = (int) f.length();
			buffer = new byte [size];
			lus = 0;
			total = 0;
			
			input = new FileInputStream(f.getAbsolutePath());
			while ((lus=input.read(buffer, total, size - total))!=-1) {
				total += lus;
				if (total==size) break;
			}
			input.close();
			
			className = f.getName().substring(0, f.getName().lastIndexOf('.'));
			defineClass (packageName + "." + className, buffer, 0, total);
		}
		
	}
	
}
