package util;

import compilateur.cspLangage.Type;

/**
 * La classe Var englobe les proprits relatives  une variable
 */
abstract public class Var {
	
	String name;
	Type type;
	VarManager parent = null;
	Var linkedVar = null;
	
	public Var (String name, Type type, VarManager parent) { 
		this.name = name;
		this.type = type;
		this.parent = parent;
	}

	public String getName () { return name; }
	public Type getType () { return type; }
	public void linkTo (Var v) {
		v.linkedVar = this;
		this.linkedVar = v;
	}
	
	public Var getLinkedVar () { return linkedVar; }
	public VarManager getParent () { return parent; }
	
	public String toString () {return name; }	
}