/*
 * Created on 27 fvr. 2005
 *
 */
package util.saveObject;

import java.util.*;

/**
 * Cette classe permet de sauvegarder des tableaux avec les classes 'OutputSaveObject'
 * et 'InputSaveObject'.
 * 
 * @author Benjamin LE BOZEC
 */
public class SavableArray implements Savable {

	private Object[] tab;
 
	/**
	 * Constucteur par dfaut
	 */
	public SavableArray () {
		tab = new Object[0];
	}
	/**
	 * @param tab Tableau a sauvegarder
	 */
	public SavableArray (Object [] tab) {
		this.tab = tab;
	}
	
	/**
	 * @param list Liste  sauvegarder
	 */
	public SavableArray (Collection list) {
		tab = list.toArray();
	}

	/**
	 * @return le tableau
	 */
	public Object [] getTab () {
		return tab;
	}

	/**
	 * Convertit le tableau en une liste linaire chaine
	 * @return un objet linkedList
	 */
	public LinkedList getLinkedList () {
		LinkedList list = new LinkedList ();
		for (int i=0;i<tab.length;i++)
			list.add (tab[i]);
		return list;
	}
	
	public void toArray (Object [] tab2) {
		for (int i=0;i<tab.length;i++)
			tab2[i] = tab[i];
	}
	
	/**
	 * @param tab Modificateur du tableau
	 */
	public void setTab(Object[] tab) {
		this.tab = tab;
	}

	/* 
	 * @see think.util.Savable#saveInto(think.util.OutputSaveObject)
	 */
	public void saveInto(OutputSaveObject sObj) throws SaveObjectException {
		sObj.add ("size", new Integer(tab.length));
		for (int i=0;i<tab.length;i++)
			sObj.add ("" + i, tab[i]);
	}

	/* 
	 * @see think.util.Savable#loadFrom(think.util.InputSaveObject)
	 */
	public void loadFrom(InputSaveObject sObj) throws SaveObjectException {
		Vector error = new Vector ();
		LinkedList list = new LinkedList();
		int size = ((Integer) sObj.getNext("size")).intValue();
		
		for (int i=0; i<size;i++)  {
			try {
				list.add(sObj.getNext ("" + i));
			} catch (SaveObjectException e) {
				error.add (e);
			}
		}
		
		tab = list.toArray();
		
		if (error.size() != 0) {
			Exception [] tabException = new Exception [error.size()];
			error.toArray(tabException);
			throw new SaveObjectException (tabException);
		}
	}
	
}
