/*
 * Created on 17 fvr. 2005
 *
 */
package util.saveObject;

/**
 * <p>Cette Exception englobe toutes les exceptions leves au cours du processus
 * de sauvegarde ou de rcupration des donnes par les classes 'OutputSaveObject'
 * et 'InputSaveObject'.
 * 
 * <p>Elle permet entre autre l'encapsulation d'exception, et ceci afin de
 * permettre aux classes utilisant 'OutputSaveObject' et 'InputSaveObject'
 * de lancer leurs propres exceptions.
 * 
 * @author Benjamin LE BOZEC
 */
public class SaveObjectException extends Exception {

	public SaveObjectException () { super (); }
	public SaveObjectException (String str) {super (str);}
	public SaveObjectException (Exception e) { super (e); }
	public SaveObjectException (Exception [] tab) { super (); this.tab = tab; }
	
	Exception [] tab;
	
	public boolean tabExists () { return tab != null; }
	public Exception [] getTab () { return tab; }
	public String toString () {
		String descr="";
		if (tabExists()) {
			for (int i=0;i<tab.length;i++)
				descr += tab[i].toString ();
		} else
			descr = super.toString ();
		return descr;
	}
}
